# -*- coding: utf-8 -*-

#
# Debrid-Link.fr addon
# 

import sys
import urllib
import urlparse
import xbmcgui
import xbmcplugin
import xbmcaddon
from resources.lib.debridlinkapi import debridlink
from os import _exit
import datetime

MEDIAS = {
    'movie' : True,
    'music' : True
}

ERRORS = {
    'noTorrent': "No file",
    'noLinks': "No file"
}

RELOG_ERROR = {
    'badToken' : True,
    'hidedToken' : True
}

base_url = sys.argv[0]
addon_handle = int(sys.argv[1])
args = urlparse.parse_qs(sys.argv[2][1:])
addon = xbmcaddon.Addon("plugin.video.debridlink")
xbmcplugin.setContent(addon_handle, 'movies')

def init():
    if loadDL():
        loatPath()

def build_url(query):
    url = base_url + '?'
    for key in query:
        url += key.encode('utf-8') +"="+ query[key].encode('utf-8') +"&"
    return url[:-1]

def getSetting(setting):
    return addon.getSetting(setting)

def setSetting(setting, value):
    addon.setSetting(setting, value)

def setSortItems():
    xbmcplugin.addSortMethod(addon_handle, xbmcplugin.SORT_METHOD_TITLE)
    xbmcplugin.addSortMethod(addon_handle, xbmcplugin.SORT_METHOD_DATE)


def addItem(url, name, ts):
    infos={}
    infos['Title'] = name
    if ts:
        infos['date'] = datetime.datetime.fromtimestamp(int(ts)).strftime("%d.%m.%Y")
    li = xbmcgui.ListItem(name)
    li.setInfo(type="Video", infoLabels = infos)
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=url, listitem=li)

def addFolder(url, name):
    li = xbmcgui.ListItem(name)
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=url, listitem=li, isFolder=True)

def loadDL():
    if DL_TOKEN and DL_KEY :
        debridlink.TOKEN = DL_TOKEN
        debridlink.KEY = DL_KEY
        return True
    elif DL_USER and DL_PASSORD:
        debridlink.USER = DL_USER
        debridlink.PASSWORD = DL_PASSORD
        debridlink.login()
        if debridlink.loged():
            setSetting('dl_token', debridlink.TOKEN)
            setSetting('dl_key', debridlink.KEY)
            return True
        else :
            xbmc.executebuiltin('Notification(Error, Unabled to connect your account,5000)')
            return False 
    else :
        xbmc.executebuiltin('Notification(Error, Configure your account before use this plugin,5000)')
        return False

def error(rslt):
    if rslt['result'] == 'OK':
        return False

    if RELOG_ERROR.get(rslt['ERR'], False) and DL_USER and DL_PASSORD:
        debridlink.USER = DL_USER
        debridlink.PASSWORD = DL_PASSORD
        debridlink.TOKEN = False
        debridlink.KEY = False
        debridlink.login()
        if debridlink.loged():
            setSetting('dl_token', debridlink.TOKEN)
            setSetting('dl_key', debridlink.KEY)
            return False

    return ERRORS.get(rslt['ERR'], '#{0}'.format(rslt['ERR']))

def isMedia(type):
    return MEDIAS.get(type, False)

def loatPath():

    parrent = "root"
    if 'mode' in args:
        parrent = args['mode'][0]

    files = debridlink.request(debridlink.routes['FILES_LIST'], {'parameters' : {':parrent' : parrent}})

    if error(files):
        xbmc.executebuiltin('Notification(Error, {0},5000)'.format(error(files)))
        return False

    for file in files['value']:
        if file['type'] == "folder":
            addFolder(build_url({'mode': file['id'], 'foldername': file['name']}), file['name'])
        elif isMedia(file['type']):
            addItem(file['downloadUrl'], file['name'], file['time'])

    setSortItems()
    xbmcplugin.endOfDirectory(addon_handle)


debridlink = debridlink()
DL_KEY = getSetting('dl_key')
DL_TOKEN = getSetting('dl_token')
DL_USER = getSetting('dl_username')
DL_PASSORD = getSetting('dl_password')

init()