#!/usr/bin/python
# -*- coding: utf-8 -*-

#
# debridlink API
# 

import urllib
import urllib2
import time
import json
import socket
import hashlib
import cookielib

class debridlink:

	LOGIN_USER = "https://debrid-link.fr/login"
	API_URL = "https://debrid-link.fr/api"
	APP_KEY = "tDZppZ1q44649cJK"
	TOKEN = False
	KEY = False
	USER = False
	PASSWORD = False
	TSD = 0

	def __init__(self):
		socket.setdefaulttimeout(10)
		self.routes = {
			'TOKEN' : "/token/:publickey/new",
			'FILES_LIST' : "/files/:parrent/list"
		}

		
	def loged(self):
		if self.KEY != False and self.TOKEN != False:
			return True
		return False

	
	def login(self):
		""" Login the user with the sessid """
		if self.loged():
			return True

		sessid = self.request(self.routes['TOKEN'],{'parameters' : {':publickey' : self.APP_KEY}})

		loc = urllib.urlopen(sessid['value']['validTokenUrl'])
		cookie = str(loc.info()).split('PHPSESSID=');
		cookie = cookie[1].split(";");
		headers = {
			'Cookie' : 'PHPSESSID={0}; token={1}'.format(cookie[0], sessid['value']['token']), 
			'User-Agent' : 'Mozilla/4.0 (compatible; MSIE 5.5; Windows NT)'
		}

		post = {'user':self.USER,'password':self.PASSWORD,'sessidTime':'all','token':sessid['value']['token'],'authorizedToken':'1','understand':'true'}
		data = urllib.urlencode(post)
		request = urllib2.Request(self.LOGIN_USER, data, headers)
		response = urllib2.urlopen(request)

		if response.read().find('alert alert-success') > 0:
			self.addToken(sessid['value']['token'])
			self.addKey(sessid['value']['key'])
			return True

	def build_real_route(self, route, parameters):
		split = route.split("/")
		for index in range(len(split)):
			if split[index] != "" and split[index][0] == ':':
				split[index] = parameters[split[index]]
		return "/".join(split)


	def request(self, route, config, retry = 0):
		retry += 1;
		maxtry = 3;
		default_route = route

		if self.loged() == False and route != self.routes['TOKEN']:
			return False

		if 'parameters' in config:
			route = self.build_real_route(route, config['parameters'])

		headers = {}
		if self.TOKEN:
			TS = self.getTSD()
			headers = {
				'X-DL-TS' : TS,
				'X-DL-TOKEN' : self.TOKEN,
				'X-DL-SIGN' : self.build_sign(route, TS)
			}

		request = urllib2.Request("".join((self.API_URL, route)), headers=headers)
		response = urllib2.urlopen(request)
		rslt = json.loads(response.read())
	  	response.close()

	  	if rslt['ts']:
	  		self.TSD = int(time.time()) - rslt['ts']

	  	if rslt['result'] == 'KO':
	  		if rslt['ERR'] == 'badSign' and retry <= maxtry:
	  			return self.request(default_route, config, retry)
	  		elif rslt['ERR'] == 'badToken':
	  			self.addToken(False)
	  			self.addKey(False)
	  	
	  	return rslt

	
	def addToken(self, token):
		self.TOKEN = token

	
	def addKey(self, key):
		self.KEY = key

	def build_sign(self, route, ts):
		return hashlib.sha1(''.join((str(ts), route, self.KEY))).hexdigest()

	def getTSD(self):
		return int(time.time()) - self.TSD;